/***********************************************************************/
/*                                                                     */
/*                       C_data_user_complex.h                         */
/*                                                                     */
/*  example of definition of the C type complex                        */
/*                                                                     */
/*  authors: D. Gaffe and A. Ressouche                                 */
/*                                                                     */
/*  version: 02/01/2019                                                */
/***********************************************************************/

#ifndef C_DATA_USER_COMPLEX_H
#define C_DATA_USER_COMPLEX_H

typedef struct
{
  double re;
  double im;
} complex;

extern const complex zero_complex;
extern complex copy_complex(complex);
extern complex add_complex(complex,complex);
extern complex sub_complex(complex,complex);
extern complex neg_complex(complex);
extern complex conj_complex(complex);
extern complex mult_complex(complex,complex);
extern complex div_complex(complex,complex);
extern double module_complex(complex);
extern double argument_complex(complex);
extern int eq_complex(complex,complex);
extern int neq_complex(complex,complex);
extern int less_complex(complex,complex);
extern int lesseq_complex(complex,complex);
extern int sup_complex(complex,complex);
extern int supeq_complex(complex,complex);
#endif
